This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 1112864 - (elpa) Review Request: elpa - High-performance library for parallel solution of eigenvalue problems
Review Request: elpa - High-performance library for parallel solution of eige...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Sandro Mani
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-SCITECH 976092
  Show dependency treegraph
 
Reported: 2014-06-24 16:57 EDT by Dominik 'Rathann' Mierzejewski
Modified: 2014-07-23 23:21 EDT (History)
3 users (show)

See Also:
Fixed In Version: elpa-2013.11-3.008.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-07-23 23:21:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
manisandro: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
port to EPEL6 (7.58 KB, patch)
2014-06-27 10:27 EDT, Dave Love
no flags Details | Diff

  None (edit)
Description Dominik 'Rathann' Mierzejewski 2014-06-24 16:57:22 EDT
Spec URL: http://rathann.fedorapeople.org/review/elpa/elpa.spec
SRPM URL: http://rathann.fedorapeople.org/review/elpa/elpa-2013.11-1.008.fc20.src.rpm
Description:
ELPA is a Fortran-based high-performance computational library for the
(massively) parallel solution of symmetric or Hermitian, standard or generalized
eigenvalue problems.

This is the kind of eigenvalue problem which is frequently encountered in
Electronic Structure Theory (solution of Schrödinger's Equation or variants
thereof), but also in many other fields. Typically, the solution effort scales
as O(size^3), where "size" is a measure of the system size, for example the
dimension of the associated matrices or the number of required
eigenvalue/eigenvector pairs (less than or equal to the matrix dimension). Thus,
an algebraically exact solution of the eigenproblem may quickly become the
bottleneck in a practical application.

Fedora Account System Username: rathann
Comment 1 Dave Love 2014-06-25 13:01:46 EDT
I've just been doing it; never mind.

Would you accept a patch for EPEL6?  (cp2k 2.5 builds on EPEL6 with devtoolset-2, and I was going to put it in copr when I'd rebuilt against elpa.)  I had to avoid patching configure since it needs more recent autotools than in EPEL6, and I'd have to check that recipe for the Fedora releases.

I can't find any packaging rules about library names, but wouldn't it be better to call it libelpa?  If nothing else it helps things like rpmorphan.

It would probably be useful to package versions with other optimizations, like sandybridge in our case, but I wasn't sure how best to do it and couldn't find any examples.  I wonder if there should be a policy on that.
Comment 2 Sandro Mani 2014-06-25 17:53:35 EDT
Issues:
- A comment why %{?_smp_mflags} is disabled would be nice
- Comment how to obtain source tarball
- Unowned directory issues:
  * No package seems to own %{_libdir}/gfortran (possibly gfortran should do so?)
  * Same goes with %{_libdir}/*mpi*/pkgconfig
- rpmlint
  * undefined-non-weak-symbol : these should be fixable my linking against the mpi / gomp libraries
  * unused-direct-shlib-dependency : could try -Wl,--as-needed

Note:
- Spec in SRPM differs

     
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that are
  listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: sed
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/gfortran, /usr/lib64/gfortran/modules,
     /usr/lib64/openmpi/lib/pkgconfig, /usr/lib64/gfortran/modules/mpich,
     /usr/lib64/mpich/lib/pkgconfig, /usr/lib64/gfortran/modules/openmpi
     => Not a blocker since there are no packages which provide these directories
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/gfortran,
     /usr/lib64/openmpi/lib, /usr/lib64/gfortran/modules, /usr/lib64/mpich,
     /usr/lib64/mpich/lib, /usr/lib64/openmpi/lib/pkgconfig,
     /usr/lib64/gfortran/modules/mpich, /usr/lib64/mpich/lib/pkgconfig,
     /usr/lib64/openmpi, /usr/lib64/gfortran/modules/openmpi
     => Not a blocker since there are no packages which provide these directories
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Package should not use obsolete m4 macros


Rpmlint
-------
Checking: elpa-common-2013.11-1.008.fc21.noarch.rpm
          elpa-mpich-2013.11-1.008.fc21.x86_64.rpm
          elpa-mpich-devel-2013.11-1.008.fc21.x86_64.rpm
          elpa-openmpi-2013.11-1.008.fc21.x86_64.rpm
          elpa-openmpi-devel-2013.11-1.008.fc21.x86_64.rpm
          elpa-2013.11-1.008.fc21.src.rpm
elpa-mpich.x86_64: W: no-documentation
elpa-mpich-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-mpich-devel.x86_64: W: no-documentation
elpa-openmpi.x86_64: W: no-documentation
elpa-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-openmpi-devel.x86_64: W: no-documentation
elpa.src: W: spelling-error %description -l en_US eigenvector -> convector
elpa.src: W: spelling-error %description -l en_US eigenproblem -> problematic
elpa.src: W: invalid-url Source0: ELPA_2013.11.tar.xz
6 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint elpa-mpich-devel elpa-openmpi-devel elpa-common elpa-openmpi elpa-mpich
elpa-mpich-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-mpich-devel.x86_64: W: no-documentation
elpa-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-openmpi-devel.x86_64: W: no-documentation
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_reduce_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_isend_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_comm_split_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_abort_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_test_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_comm_rank_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_sendrecv_replace_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_wait_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_wtime_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_waitall_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_sendrecv_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_irecv_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_barrier_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_alltoallv_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_recv_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_send_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_allreduce_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_comm_size_
elpa-openmpi.x86_64: W: undefined-non-weak-symbol /usr/lib64/openmpi/lib/libelpa.so.0.0.0 mpi_bcast_
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 libscalapack.so.2
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 libmpiblacs.so.2
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /lib64/libstdc++.so.6
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /lib64/libgcc_s.so.1
elpa-openmpi.x86_64: W: no-documentation
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_reduce_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 GOMP_parallel
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_isend_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_comm_split_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_abort_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_test_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_comm_rank_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_sendrecv_replace_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_wait_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_wtime_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 omp_get_thread_num_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_waitall_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_sendrecv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_irecv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_barrier_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 omp_get_num_threads_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 omp_get_num_threads
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_alltoallv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_recv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_send_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_allreduce_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 omp_get_max_threads_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 GOMP_barrier
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_comm_size_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 omp_get_thread_num
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 mpi_bcast_
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 libscalapack.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 libmpiblacs.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/libstdc++.so.6
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/libgcc_s.so.1
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_reduce_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_isend_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_comm_split_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_abort_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_test_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_comm_rank_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_sendrecv_replace_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_wait_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_wtime_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_waitall_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_sendrecv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_irecv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_barrier_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_alltoallv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_recv_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_send_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_allreduce_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_comm_size_
elpa-mpich.x86_64: W: undefined-non-weak-symbol /usr/lib64/mpich/lib/libelpa.so.0.0.0 mpi_bcast_
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 libscalapack.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 libmpiblacs.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/libstdc++.so.6
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/libgcc_s.so.1
elpa-mpich.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 82 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/sandro/.Data/Desktop/1112864-elpa/srpm/elpa.spec	2014-06-25 15:52:47.784991580 +0200
+++ /home/sandro/.Data/Desktop/1112864-elpa/srpm-unpacked/elpa.spec	2014-06-24 10:56:21.000000000 +0200
@@ -195,5 +195,4 @@
 rm %{buildroot}%{_bindir}/test*
 
-%if 0
 %check
 %{_mpich_load}
@@ -212,5 +211,4 @@
 popd
 %{_openmpi_unload}
-%endif
 
 %post mpich -p /sbin/ldconfig


Requires
--------
elpa-mpich-devel (rpmlib, GLIBC filtered):
    elpa-mpich(x86-64)
    libelpa.so.0()(64bit)
    libelpa_mt.so.0()(64bit)

elpa-openmpi-devel (rpmlib, GLIBC filtered):
    elpa-openmpi(x86-64)
    libelpa.so.0()(64bit)

elpa-common (rpmlib, GLIBC filtered):

elpa-openmpi (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    blacs-openmpi
    elpa-common
    libblas.so.3()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    liblapack.so.3()(64bit)
    libm.so.6()(64bit)
    libmpiblacs.so.2()(64bit)
    libscalapack.so.2()(64bit)
    libstdc++.so.6()(64bit)
    rtld(GNU_HASH)
    scalapack-openmpi

elpa-mpich (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    blacs-mpich
    elpa-common
    libblas.so.3()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    liblapack.so.3()(64bit)
    libm.so.6()(64bit)
    libmpiblacs.so.2()(64bit)
    libscalapack.so.2()(64bit)
    libstdc++.so.6()(64bit)
    rtld(GNU_HASH)
    scalapack-mpich



Provides
--------
elpa-mpich-devel:
    elpa-mpich-devel
    elpa-mpich-devel(x86-64)

elpa-openmpi-devel:
    elpa-openmpi-devel
    elpa-openmpi-devel(x86-64)

elpa-common:
    elpa-common

elpa-openmpi:
    elpa-openmpi
    elpa-openmpi(x86-64)
    libelpa.so.0()(64bit)

elpa-mpich:
    elpa-mpich
    elpa-mpich(x86-64)
    libelpa.so.0()(64bit)
    libelpa_mt.so.0()(64bit)



Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1112864
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 3 Dominik 'Rathann' Mierzejewski 2014-06-26 04:36:59 EDT
(In reply to Dave Love from comment #1)
> I've just been doing it; never mind.
> 
> Would you accept a patch for EPEL6?

Of course. I'll most likely keep it in that branch only, though.

> I can't find any packaging rules about library names, but wouldn't it be
> better to call it libelpa?  If nothing else it helps things like rpmorphan.

Upstream calls it ELPA. The naming (https://fedoraproject.org/wiki/Packaging:NamingGuidelines) guidelines don't mandate any lib* prefix for libraries and suggest using upstream naming.

> It would probably be useful to package versions with other optimizations,
> like sandybridge in our case, but I wasn't sure how best to do it and
> couldn't find any examples.  I wonder if there should be a policy on that.

atlas and qtwebkit do something like that, for example, but only for i686 with and without SSE2 support. Unfortunately, hwcap support is completely undocumented (see my 6 year old bug: https://sourceware.org/bugzilla/show_bug.cgi?id=7100) and no hwcaps are defined on x86_64 (check /usr/include/bits/hwcap.h on your system).
Comment 4 Dave Love 2014-06-26 07:27:21 EDT
(In reply to Sandro Mani from comment #2)
> - Unowned directory issues:
>   * No package seems to own %{_libdir}/gfortran (possibly gfortran should do
> so?)

In case it's not clear, the guidelines say the devel package needs

Requires:	gcc-gfortran%{_isa}

>   * Same goes with %{_libdir}/*mpi*/pkgconfig

It looks like an openmpi packaging bug, at least in EPEL6.  Its environment
module file references the directory, but the package doesn't create it.
The mpich2 module file doesn't add to PKG_CONFIG_PATH.
This looks like something which should be added to the MPI packaging guidelines.
I'd assumed the pc files should have MPI-specific names in the usual directory,
put having them in the MPI tree seems sensible.
Comment 5 Sandro Mani 2014-06-26 08:31:52 EDT
I've filed [1] about the %{_libdir}/gfortran issue. In the meantime, yes please require gcc-gfortran as the guidelines state.


[1] https://bugzilla.redhat.com/show_bug.cgi?id=1113564
Comment 6 Dominik 'Rathann' Mierzejewski 2014-06-26 08:53:21 EDT
(In reply to Sandro Mani from comment #2)
> Issues:
> - A comment why %{?_smp_mflags} is disabled would be nice
> - Comment how to obtain source tarball

Fixed. After talking to upstream again, I found the right homepage URL and links to source tarballs there.

> - Unowned directory issues:
>   * No package seems to own %{_libdir}/gfortran (possibly gfortran should do
> so?)

Fixed by adding the missing Requires on gcc-gfortran, as Dave pointed out.

>   * Same goes with %{_libdir}/*mpi*/pkgconfig
> - rpmlint
>   * undefined-non-weak-symbol : these should be fixable my linking against
> the mpi / gomp libraries

I managed to fix that, but I'm still getting undefined symbols due to a bug in scalapack package. Bug 1113567 filed.

>   * unused-direct-shlib-dependency : could try -Wl,--as-needed

It fails at linking when I add that. Also, these come from linking with mpif90 (which is as it turns out required to avoid the undefined mpi symbols). I'll keep trying to fix that.

> Note:
> - Spec in SRPM differs

I'll keep the %if 0 there to allow disabling tests for quick local builds.

New spec and srpm:

http://rathann.fedorapeople.org/review/elpa/elpa.spec
http://rathann.fedorapeople.org/review/elpa/elpa-2013.11-2.008.fc20.src.rpm

* Thu Jun 26 2014 Dominik Mierzejewski <rpm@greysector.net> 2013.11-2.008
- remove executable stack from installed libraries
- fix undefined non-weak mpi symbols
- reorder build section and drop some redundant parts
- add missing gfortran Requires for -devel subpackages
- use correct URL and provide link to source tarball
Comment 7 Dave Love 2014-06-26 09:58:58 EDT
> >   * Same goes with %{_libdir}/*mpi*/pkgconfig
> 
> It looks like an openmpi packaging bug, at least in EPEL6.  Its environment
> module file references the directory, but the package doesn't create it.

Sorry, ignore that.  The module file I had was actually from the fedora-19
package.  In RHEL, and later Fedora by the looks of it, pkg-config won't
normally find the pc files in the MPI tree.
Comment 8 Sandro Mani 2014-06-26 10:04:59 EDT
> Sorry, ignore that.  The module file I had was actually from the fedora-19 package.  In RHEL, and later Fedora by the looks of it, pkg-config won't normally find the pc files in the MPI tree.

In my opinion the openmpi module file should set PKG_CONFIG_PATH to point to the corresponding directory. According to the pkg-config manpage, the default directory will always be searched after PKG_CONFIG_PATH. So it would make perfect sense to override it.

Note that also other packages install .pc files in $MPI_LIB/pkg-config.
Comment 10 Dave Love 2014-06-27 10:26:23 EDT
(In reply to Dominik 'Rathann' Mierzejewski from comment #3)

> > Would you accept a patch for EPEL6?
> 
> Of course. I'll most likely keep it in that branch only, though.

I'll attach the patch I've built with, though it's messy.

> > It would probably be useful to package versions with other optimizations,
> > like sandybridge in our case, but I wasn't sure how best to do it and
> > couldn't find any examples.  I wonder if there should be a policy on that.
> 
> atlas and qtwebkit do something like that, for example, but only for i686
> with and without SSE2 support. 

I hadn't realized atlas was doing that now -- I use openblas when possible.
Actually atlas has x86_64 sse2/sse3 versions.  I'll look at doing something similar
with ELPA unless there's a good reason not to.

> Unfortunately, hwcap support is completely
> undocumented (see my 6 year old bug:
> https://sourceware.org/bugzilla/show_bug.cgi?id=7100) and no hwcaps are
> defined on x86_64 (check /usr/include/bits/hwcap.h on your system).

Yes, I'd ruled it out long ago, even though it seems to be just what's needed
on a typical heterogeneous HPC system.  Linux fails to do several things right
that would really help HPC...
Comment 11 Dave Love 2014-06-27 10:27:41 EDT
Created attachment 912845 [details]
port to EPEL6
Comment 12 Sandro Mani 2014-06-28 10:30:53 EDT
Hmpf, didn't notice that my comment wasn't submitted due to mid-air collission... Anyway, the comment was:


elpa-openmpi.x86_64: W: executable-stack /usr/lib64/openmpi/lib/libelpa.so.0.0.0

Rest is good!
Comment 13 Dave Love 2014-06-29 06:38:52 EDT
The execstack call has a typo -- "mpich" should be "$mpi".

Shouldn't it link against openblas/atlas rather than reference blas?
Comment 14 Dominik 'Rathann' Mierzejewski 2014-06-29 18:42:23 EDT
(In reply to Dave Love from comment #11)
> Created attachment 912845 [details]
> port to EPEL6

Thanks a lot, but I don't think it's worth it to maintain the same spec file across all branches at all cost. I think it'd be easier to drop all non-EL6 parts from the spec alltogether for the EL6 branch. Could you post a diff doing that? Also, please feel encouraged to apply for co-maintainership after this package is approved.
Comment 15 Dominik 'Rathann' Mierzejewski 2014-06-29 18:45:54 EDT
(In reply to Sandro Mani from comment #12)
> Hmpf, didn't notice that my comment wasn't submitted due to mid-air
> collission... Anyway, the comment was:
> 
> 
> elpa-openmpi.x86_64: W: executable-stack
> /usr/lib64/openmpi/lib/libelpa.so.0.0.0

Fixed.

(In reply to Dave Love from comment #13)
> The execstack call has a typo -- "mpich" should be "$mpi".
> 
> Shouldn't it link against openblas/atlas rather than reference blas?

It is build against atlas now. openblas doesn't support ARM yet. Do you think it's worth it to build against openblas on x86/x86_64 and atlas on ARM?

New spec and srpm:

http://rathann.fedorapeople.org/review/elpa/elpa.spec
http://rathann.fedorapeople.org/review/elpa/elpa-2013.11-3.008.fc20.src.rpm

* Sun Jun 29 2014 Dominik Mierzejewski <rpm@greysector.net> 2013.11-3.008
- fix typo in execstack -c call
- link against atlas
Comment 16 Sandro Mani 2014-07-01 03:33:07 EDT
The reason for
# %{?_smp_mflags}
should be documented with a comment. But this is not a blocker.

Rest is fine, package approved!


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/gfortran, /usr/lib64/gfortran/modules,
     /usr/lib64/openmpi/lib/pkgconfig, /usr/lib64/gfortran/modules/mpich,
     /usr/lib64/mpich/lib/pkgconfig, /usr/lib64/gfortran/modules/openmpi
     => These directories should be owned by gcc-gfortran resp openmpi/mpich, which are listed as Requires
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/gfortran,
     /usr/lib64/openmpi/lib, /usr/lib64/gfortran/modules, /usr/lib64/mpich,
     /usr/lib64/mpich/lib, /usr/lib64/openmpi/lib/pkgconfig,
     /usr/lib64/gfortran/modules/mpich, /usr/lib64/mpich/lib/pkgconfig,
     /usr/lib64/openmpi, /usr/lib64/gfortran/modules/openmpi
     => These directories should be owned by gcc-gfortran resp openmpi/mpich, which are listed as Requires
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: elpa-common-2013.11-3.008.fc21.noarch.rpm
          elpa-mpich-2013.11-3.008.fc21.x86_64.rpm
          elpa-mpich-devel-2013.11-3.008.fc21.x86_64.rpm
          elpa-openmpi-2013.11-3.008.fc21.x86_64.rpm
          elpa-openmpi-devel-2013.11-3.008.fc21.x86_64.rpm
          elpa-2013.11-3.008.fc21.src.rpm
elpa-mpich.x86_64: W: no-documentation
elpa-mpich-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-mpich-devel.x86_64: W: no-documentation
elpa-openmpi.x86_64: W: no-documentation
elpa-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-openmpi-devel.x86_64: W: no-documentation
elpa.src: W: spelling-error %description -l en_US eigenvector -> convector
elpa.src: W: spelling-error %description -l en_US eigenproblem -> problematic
elpa.src: W: invalid-url Source0: ELPA_2013.11.008_20140321.tar.gz
6 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint elpa-mpich-devel elpa-openmpi-devel elpa-common elpa-openmpi elpa-mpich
elpa-mpich-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-mpich-devel.x86_64: W: no-documentation
elpa-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
elpa-openmpi-devel.x86_64: W: no-documentation
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /usr/lib64/openmpi/lib/libscalapack.so.2
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /usr/lib64/openmpi/lib/libmpiblacs.so.2
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /usr/lib64/openmpi/lib/libmpi.so.1
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /lib64/libquadmath.so.0
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /lib64/libpthread.so.0
elpa-openmpi.x86_64: W: unused-direct-shlib-dependency /usr/lib64/openmpi/lib/libelpa.so.0.0.0 /lib64/libgcc_s.so.1
elpa-openmpi.x86_64: W: no-documentation
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /usr/lib64/mpich/lib/libscalapack.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /usr/lib64/mpich/lib/libmpiblacs.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /usr/lib64/mpich/lib/libmpichf90.so.12
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /usr/lib64/mpich/lib/libopa.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /usr/lib64/mpich/lib/libmpl.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/librt.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/libquadmath.so.0
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/libpthread.so.0
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa_mt.so.0.0.0 /lib64/libgcc_s.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /usr/lib64/mpich/lib/libscalapack.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /usr/lib64/mpich/lib/libmpiblacs.so.2
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /usr/lib64/mpich/lib/libmpichf90.so.12
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /usr/lib64/mpich/lib/libopa.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /usr/lib64/mpich/lib/libmpl.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/librt.so.1
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/libpthread.so.0
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/libquadmath.so.0
elpa-mpich.x86_64: W: unused-direct-shlib-dependency /usr/lib64/mpich/lib/libelpa.so.0.0.0 /lib64/libgcc_s.so.1
elpa-mpich.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 30 warnings.
# echo 'rpmlint-done:'



Requires
--------
elpa-mpich-devel (rpmlib, GLIBC filtered):
    elpa-mpich(x86-64)
    gcc-gfortran(x86-64)
    libelpa.so.0()(64bit)
    libelpa_mt.so.0()(64bit)

elpa-openmpi-devel (rpmlib, GLIBC filtered):
    elpa-openmpi(x86-64)
    gcc-gfortran(x86-64)
    libelpa.so.0()(64bit)

elpa-common (rpmlib, GLIBC filtered):

elpa-openmpi (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    blacs-openmpi
    elpa-common
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgfortran.so.3()(64bit)
    libgfortran.so.3(GFORTRAN_1.0)(64bit)
    libgfortran.so.3(GFORTRAN_1.4)(64bit)
    libm.so.6()(64bit)
    libmpi.so.1()(64bit)
    libmpi_mpifh.so.2()(64bit)
    libmpi_usempi.so.1()(64bit)
    libmpiblacs.so.2()(64bit)
    libpthread.so.0()(64bit)
    libquadmath.so.0()(64bit)
    libsatlas.so.3()(64bit)
    libscalapack.so.2()(64bit)
    rtld(GNU_HASH)
    scalapack-openmpi

elpa-mpich (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    blacs-mpich
    elpa-common
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgfortran.so.3()(64bit)
    libgfortran.so.3(GFORTRAN_1.0)(64bit)
    libgfortran.so.3(GFORTRAN_1.4)(64bit)
    libgomp.so.1()(64bit)
    libgomp.so.1(GOMP_1.0)(64bit)
    libgomp.so.1(GOMP_4.0)(64bit)
    libgomp.so.1(OMP_1.0)(64bit)
    libm.so.6()(64bit)
    libmpiblacs.so.2()(64bit)
    libmpich.so.12()(64bit)
    libmpichf90.so.12()(64bit)
    libmpl.so.1()(64bit)
    libopa.so.1()(64bit)
    libpthread.so.0()(64bit)
    libquadmath.so.0()(64bit)
    librt.so.1()(64bit)
    libsatlas.so.3()(64bit)
    libscalapack.so.2()(64bit)
    rtld(GNU_HASH)
    scalapack-mpich



Provides
--------
elpa-mpich-devel:
    elpa-mpich-devel
    elpa-mpich-devel(x86-64)

elpa-openmpi-devel:
    elpa-openmpi-devel
    elpa-openmpi-devel(x86-64)

elpa-common:
    elpa-common

elpa-openmpi:
    elpa-openmpi
    elpa-openmpi(x86-64)
    libelpa.so.0()(64bit)

elpa-mpich:
    elpa-mpich
    elpa-mpich(x86-64)
    libelpa.so.0()(64bit)
    libelpa_mt.so.0()(64bit)



Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1112864
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 17 Dominik 'Rathann' Mierzejewski 2014-07-01 04:52:07 EDT
New Package SCM Request
=======================
Package Name: elpa
Short Description: High-performance library for parallel solution of eigenvalue problems
Upstream URL: http://elpa.rzg.mpg.de/
Owners: rathann
Branches: f19 f20 epel7 el6
InitialCC:
Comment 18 Jon Ciesla 2014-07-01 08:13:21 EDT
Git done (by process-git-requests).
Comment 19 Dave Love 2014-07-01 12:26:08 EDT
(In reply to Dominik 'Rathann' Mierzejewski from comment #15)

> It is build against atlas now. openblas doesn't support ARM yet. Do you
> think it's worth it to build against openblas on x86/x86_64 and atlas on ARM?

I don't know what difference it makes in this case, but I'd expect openblas to
be maybe twice as fast on sandybridge for DGEMM-based things, at least with the
packaged versions.  However, when I tried to compare atlas recently, I got
strange, non-reproducible results that I haven't tried to understand.

If the tests in the ELPA source make a reasonable benchmark, I could maybe
try, but I think they didn't run for long.

cp2k built with openblas, fftw, and openmpi actually seemed to out-perform a version
built with all-intel on a similar cluster on the one case I had a report for, but
I haven't tried very serious comparisons, and I've just discovered that the Fedora
fftw isn't avx enabled.  I'd forgotten to file an issue suggesting it should use
openblas.
Comment 20 Dominik 'Rathann' Mierzejewski 2014-07-02 09:08:50 EDT
Bug 1115220 filed for EPEL7 branch blocker. I'll work on building parallel-installable optimized versions, too. As for building against openblas, this would either have to be a distro-wide switch or we should mandate (via Guidelines change) that all alternative blas/lapack implementation provide a drop-in replacement ABI-compatible libraries for libblas.so.* and liblapack.so.*. The latter would have my +1 in a FPC vote.
Comment 21 Fedora Update System 2014-07-03 16:12:26 EDT
elpa-2013.11-3.008.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/elpa-2013.11-3.008.fc19
Comment 22 Fedora Update System 2014-07-03 16:13:36 EDT
elpa-2013.11-3.008.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/elpa-2013.11-3.008.fc20
Comment 23 Fedora Update System 2014-07-04 08:28:46 EDT
elpa-2013.11-3.008.fc20 has been pushed to the Fedora 20 testing repository.
Comment 24 Fedora Update System 2014-07-23 23:21:21 EDT
elpa-2013.11-3.008.fc19 has been pushed to the Fedora 19 stable repository.
Comment 25 Fedora Update System 2014-07-23 23:21:34 EDT
elpa-2013.11-3.008.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.